#!/home/john/local/bin/julia

"""
  GTK interface to ASI-ZWO camera control
  
  Uses the Observables package for GTK4 widget input and output
  
"""  

using Gtk4, Gtk4.GLib

win = GtkWindow("ZWO Camera Control", 600, 200)

vbox = GtkBox(:v)


win[] = vbox

b1 = GtkButton("1")
b2 = GtkButton("2")
b3 = GtkButton("3")


b4 = GtkButton("4")
b5 = GtkButton("5")
b6 = GtkButton("6")

tl = GtkLabel("0")
ab = GtkButton("Action")
mb = GtkLabel(" Message area ")

b1.label = "9"
tl.label = string(rand(-10:10))

hbox1 = push!(GtkBox(:h), b1, b2, b3)
hbox2 = push!(GtkBox(:h), b4, b5, b6)

push!(vbox, GtkLabel("This is a label"), hbox1, hbox2, tl, ab, mb)

action_flag = false
function ab_cb(widget)
  global action_flag = !action_flag
  message = "Setting action flag to "*string(action_flag)
  #println(message)
  mb.label = message
end

function update_status()
  tl.label = string(rand(-10:10))
  return true
end

signal_connect(ab_cb, ab, "clicked")
g_timeout_add(update_status, 250, true)

if !isinteractive()
    c = Condition()
    signal_connect(win, :close_request) do widget
        notify(c)
    end
    @async Gtk4.GLib.glib_main()
    wait(c)
end
